package cn.estsh.i3plus.ext.mes.pcn.pojo.context;

import io.swagger.annotations.ApiParam;
import lombok.Data;

import java.io.Serializable;

/**
 * 生产过程上下文对象-产品加工规则(非排序)
 */
@Data
public class MesProdRuleNoSortContext implements Serializable {

    private static final long serialVersionUID = -6129403108477819932L;

    @ApiParam(name = "进料零件号")
    private String inPartNo;

    @ApiParam(name = "产成零件号")
    private String outPartNo;

    @ApiParam(name = "设备代码")
    private String equipmentCode;

    @ApiParam(name = "进料零件规则")
    private String inPartNoRule;

    @ApiParam(name = "是否打印条码")
    private Integer isPrint;

    @ApiParam(name = "是否有装配件")
    private Integer isHasBind;

    @ApiParam(name = "汇报方式")
    private Integer reportType;

    @ApiParam(name = "是否验证加工单数量")
    private Integer isCheckOrderQty;

    @ApiParam(name = "是否包装")
    private Integer isPackage;

    @ApiParam(name = "是否验证装配件扫描顺序")
    private Integer isCheckBindSeq;

    @ApiParam(name = "成品站点")
    private String partLocation;

    @ApiParam(name = "子箱设备信号点")
    private String packageEquSignal;

    @ApiParam(name = "装配件待绑定清单 ([JSON]List<MesProductionAssemblyNosortContext>)")
    private String productionAssemblyDataJson;

}
